/*
 * Copyright (C) 2009 Geometer Plus <contact@geometerplus.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */

#ifndef __LITRESLINK_H__
#define __LITRESLINK_H__


#include <map>
#include <string>

#include "../NetworkLink.h"

class LitResLink : public NetworkLink {

private:
	static std::map<std::string, std::string> ourGenres;
	static void loadGenres();
	static void fillGenres(const std::string &tag, std::vector<std::string> &ids);

public:
	LitResLink();

	shared_ptr<ZLNetworkData> simpleSearchData(SearchResult &result, const std::string &pattern);
	shared_ptr<ZLNetworkData> advancedSearchData(SearchResult &result, const std::string &title, const std::string &author, const std::string &series, const std::string &tag, const std::string &annotation);
};

#endif /* __LITRESLINK_H__ */
